<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ListaLinhasDocTransXMLResponse StructType
 * @subpackage Structs
 */
class ListaLinhasDocTransXMLResponse extends AbstractStructBase
{
    /**
     * The ListaLinhasDocTransXMLResult
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $ListaLinhasDocTransXMLResult;
    /**
     * The mensagem
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $mensagem;
    /**
     * The sucesso
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var bool
     */
    public $sucesso;
    /**
     * Constructor method for ListaLinhasDocTransXMLResponse
     * @uses ListaLinhasDocTransXMLResponse::setListaLinhasDocTransXMLResult()
     * @uses ListaLinhasDocTransXMLResponse::setMensagem()
     * @uses ListaLinhasDocTransXMLResponse::setSucesso()
     * @param string $listaLinhasDocTransXMLResult
     * @param string $mensagem
     * @param bool $sucesso
     */
    public function __construct($listaLinhasDocTransXMLResult = null, $mensagem = null, $sucesso = null)
    {
        $this
            ->setListaLinhasDocTransXMLResult($listaLinhasDocTransXMLResult)
            ->setMensagem($mensagem)
            ->setSucesso($sucesso);
    }
    /**
     * Get ListaLinhasDocTransXMLResult value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getListaLinhasDocTransXMLResult()
    {
        return isset($this->ListaLinhasDocTransXMLResult) ? $this->ListaLinhasDocTransXMLResult : null;
    }
    /**
     * Set ListaLinhasDocTransXMLResult value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $listaLinhasDocTransXMLResult
     * @return \StructType\ListaLinhasDocTransXMLResponse
     */
    public function setListaLinhasDocTransXMLResult($listaLinhasDocTransXMLResult = null)
    {
        // validation for constraint: string
        if (!is_null($listaLinhasDocTransXMLResult) && !is_string($listaLinhasDocTransXMLResult)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($listaLinhasDocTransXMLResult)), __LINE__);
        }
        if (is_null($listaLinhasDocTransXMLResult) || (is_array($listaLinhasDocTransXMLResult) && empty($listaLinhasDocTransXMLResult))) {
            unset($this->ListaLinhasDocTransXMLResult);
        } else {
            $this->ListaLinhasDocTransXMLResult = $listaLinhasDocTransXMLResult;
        }
        return $this;
    }
    /**
     * Get mensagem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getMensagem()
    {
        return isset($this->mensagem) ? $this->mensagem : null;
    }
    /**
     * Set mensagem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $mensagem
     * @return \StructType\ListaLinhasDocTransXMLResponse
     */
    public function setMensagem($mensagem = null)
    {
        // validation for constraint: string
        if (!is_null($mensagem) && !is_string($mensagem)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mensagem)), __LINE__);
        }
        if (is_null($mensagem) || (is_array($mensagem) && empty($mensagem))) {
            unset($this->mensagem);
        } else {
            $this->mensagem = $mensagem;
        }
        return $this;
    }
    /**
     * Get sucesso value
     * @return bool|null
     */
    public function getSucesso()
    {
        return $this->sucesso;
    }
    /**
     * Set sucesso value
     * @param bool $sucesso
     * @return \StructType\ListaLinhasDocTransXMLResponse
     */
    public function setSucesso($sucesso = null)
    {
        // validation for constraint: boolean
        if (!is_null($sucesso) && !is_bool($sucesso)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($sucesso)), __LINE__);
        }
        $this->sucesso = $sucesso;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ListaLinhasDocTransXMLResponse
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
